#!/usr/bin/perl

$inDir = $ARGV[0]; # directory containing pwm files
$fileExt = $ARGV[1]; # extension of pwm files
$outFile = $ARGV[2]; # output file

open(OUT, ">$outFile");
opendir (DIR, $inDir) || die ("Can't open directory $inDir\n");
@files = readdir DIR;
foreach $file (@files) {
    @fname = split(/\./, $file);
    $pwmLabel = shift(@fname);
    $ext = pop(@fname);

    next unless ($ext eq $fileExt);

    open(IN, "$inDir/$file");
    @pwm = ();
    for $letter ( 0 .. 3 ) {
	$pwmline = <IN>;
	chomp($pwmline);
	$pwmline =~ s/^\s+//; # remove leading and trailing whitespace
	@pwmlinearr = split(/\s+/, $pwmline);
	for $pos ( 0 .. $#pwmlinearr ) {
	    $pwm[$pos][$letter] = $pwmlinearr[$pos];
	}
    }
    close(IN);

    print OUT "> $pwmLabel\n";
    for $pos ( 0 .. $#pwmlinearr ) {
	print OUT "=";
	for $letter ( 0 .. 3 ) {
	    print OUT "\t$pwm[$pos][$letter]";
	}
	print OUT "\n";
    }
    print OUT "\n";

}
closedir(DIR);
close(OUT);
