#!/bin/bash

JPATH=/usr/bin
CPATH=../javaCode/classes
THISDIR=`pwd`

outdir=output

pseudocounts=0.25
background_file=../Background/all_protein_coding.genes.-1000_0.background.m0.txt
background_file_m1=../Background/all_protein_coding.genes.-1000_0.background.m1.txt

pwm_file=../PWMs/ath_pwms.jfmt.txt
threshold_file=../Thresholds/get-WMM-cutoff-method/cutoffs_m1/ath_pwms.thresholds.FP.0.0001.txt

seqs_file=../Sequences/seqs_to_scan.fa

output_file=$outdir/seqs_to_scan_hits

cd $CPATH
strands=( FWD REV )
for strand in ${strands[@]}
do
    $JPATH/java -Xms500m -Xmx500m scancode.Scan $pseudocounts $strand $THISDIR/$pwm_file $THISDIR/$threshold_file $THISDIR/$seqs_file $THISDIR/$output_file $THISDIR/$background_file $THISDIR/$background_file_m1 &
done
