#!/usr/bin/perl

$bgfile = shift;
$cutoffType = shift;
$bins = shift;
$samples = shift;
$bgorder = shift;
$cutoff = shift;
$indir = shift;
$threshFile = shift;
$withHistText = shift;

$withHist = 0;
if ($withHistText eq "HIST") {
    $withHist = 1;
}

@pwmlist = ();
open(LIST, "$indir/pwms.list") || die("Can't open $indir/pwms.list\n");
while (<LIST>) {
    $line = $_;
    chomp($line);
    push(@pwmlist, $line);
}
close(LIST);

open(OUT, ">$threshFile");
foreach $name (@pwmlist) {
    print "processing $name\n";
    $wmmfile = "$indir/$name.wmm";
    $histfile = "$indir/$name.hist";
    $commandscript = "./get-WMM-cutoff";
    $commandfiles = "$wmmfile $bgfile $cutoff";
    $commandopts = "-d $cutoffType -b $bins -s $samples -o $bgorder -M";
    if ($withHist) {
	$commandopts .= " -h $histfile";
    }
    $command = "$commandscript $commandopts $commandfiles";
    $thresh = `$command`;
    print OUT "$name\t$thresh";
}
close(OUT);
