#!/usr/bin/perl

$inPwms = shift;

@pathparts = split(/\//, $inPwms);
$fname = pop(@pathparts);
@parts = split(/\./, $fname);
$dirname = shift(@parts);
unless(-d $dirname){
    mkdir $dirname or die "Couldn't create dir: [$dirname] ($!)";
}

@pwmlist = ();
open(PWMS, $inPwms) || die("Can't open $inPwms\n");
while (<PWMS>) {
    $line = $_;
    chomp($line);
    if ($line =~ /^>/) {
	($jnk, $name) = split(/\s+/, $line);
	@pwm = ();
	$nline = <PWMS>;
	chomp($nline);
	$pos = 0;
	while($nline =~ /^=/) {
	    @narr = split(/\s+/, $nline);
	    $eq = shift(@narr);
	    for $letter (0 .. 3) {
		$pwm[$letter][$pos] = $narr[$letter];
	    }
	    $nline = <PWMS>;
	    chomp($nline);
	    $pos++;
	}

	open(OUT, ">$dirname/$name.pfm");
	for $letter ( 0 .. 3 ) {
	    $first = 1;
	    for $pos (0 .. $#{$pwm[$letter]}) {
		unless ($first) { print OUT "\t"; }
		print OUT "$pwm[$letter][$pos]";
		$first = 0;
	    }
	    print OUT "\n";
	}
	close(OUT);
	
	push(@pwmlist, $name);
    }
}
close(PWMS);

open(OUT, ">$dirname/pwms.list");
for $i (0 .. $#pwmlist) {
    print OUT "$pwmlist[$i]\n";
}
close(OUT);
