package scancode;

/**
 * Copyright (C) 2010  Molly Megraw
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: molly.megraw@duke.edu
 *
 */
public class Utils {

    public static double[][] PWMRevCmp(double[][] pwm) {
        double[][] pwm_revcmp = new double[pwm.length][Setup.NCHARS];
        double[][] pwm_tmp = new double[pwm.length][Setup.NCHARS];

        // Complement: flip columns representing A,T and C,G
        for (int mp = 0; mp < pwm.length; mp++) {
            pwm_tmp[mp][Setup.charInd('A')] = pwm[mp][Setup.charInd('T')];
            pwm_tmp[mp][Setup.charInd('T')] = pwm[mp][Setup.charInd('A')];
            pwm_tmp[mp][Setup.charInd('C')] = pwm[mp][Setup.charInd('G')];
            pwm_tmp[mp][Setup.charInd('G')] = pwm[mp][Setup.charInd('C')];
        }

        // Reverse: invert row order
        for (int mp = 0; mp < pwm.length; mp++) {
            int revmp = (pwm.length - 1) - mp;
            System.arraycopy(pwm_tmp[mp], 0, pwm_revcmp[revmp], 0, Setup.NCHARS);
        }

        return pwm_revcmp;
    }

}
